linutil/src/commands/system-setup/system-update.sh

109 lines
3.7 KiB
Bash
Raw Normal View History

2024-07-15 20:00:04 +01:00
#!/bin/sh -e
. ../common-script.sh
2024-07-13 02:57:34 +01:00
fastUpdate() {
case ${PACKAGER} in
pacman)
if ! command_exists yay && ! command_exists paru; then
echo "Installing yay as AUR helper..."
2024-08-23 14:12:47 +01:00
$ESCALATION_TOOL ${PACKAGER} -S --needed --noconfirm base-devel || { echo -e "${RED}Failed to install base-devel${RC}"; exit 1; }
cd /opt && $ESCALATION_TOOL git clone https://aur.archlinux.org/yay-git.git && $ESCALATION_TOOL chown -R ${USER}:${USER} ./yay-git
cd yay-git && makepkg --noconfirm -si || { echo -e "${RED}Failed to install yay${RC}"; exit 1; }
2024-07-13 02:57:34 +01:00
else
echo "Aur helper already installed"
2024-07-13 02:57:34 +01:00
fi
if command_exists yay; then
AUR_HELPER="yay"
elif command_exists paru; then
AUR_HELPER="paru"
else
echo "No AUR helper found. Please install yay or paru."
2024-07-13 02:57:34 +01:00
exit 1
fi
2024-08-23 14:12:47 +01:00
$AUR_HELPER -S --needed --noconfirm rate-mirrors-bin
2024-07-18 21:44:20 +01:00
if [ -s /etc/pacman.d/mirrorlist ]; then
2024-08-23 14:12:47 +01:00
$ESCALATION_TOOL cp /etc/pacman.d/mirrorlist /etc/pacman.d/mirrorlist.bak
2024-07-18 21:44:20 +01:00
fi
# If for some reason DTYPE is still unknown use always arch so the rate-mirrors does not fail
2024-07-14 03:16:02 +01:00
dtype_local=${DTYPE}
if [ "${DTYPE}" = "unknown" ]; then
dtype_local="arch"
fi
2024-08-23 14:12:47 +01:00
$ESCALATION_TOOL rate-mirrors --top-mirrors-number-to-retest=5 --disable-comments --save /etc/pacman.d/mirrorlist --allow-root ${dtype_local}
2024-07-13 02:57:34 +01:00
;;
apt-get|nala)
2024-08-23 14:12:47 +01:00
$ESCALATION_TOOL apt-get update
2024-07-14 05:02:52 +01:00
if ! command_exists nala; then
2024-08-23 14:12:47 +01:00
$ESCALATION_TOOL apt-get install -y nala || { echo -e "${YELLOW}Falling back to apt-get${RC}"; PACKAGER="apt-get"; }
2024-07-14 05:02:52 +01:00
fi
if [ "${PACKAGER}" = "nala" ]; then
2024-08-23 14:12:47 +01:00
$ESCALATION_TOOL cp /etc/apt/sources.list /etc/apt/sources.list.bak
$ESCALATION_TOOL nala update
2024-07-14 05:02:52 +01:00
PACKAGER="nala"
fi
2024-08-23 14:12:47 +01:00
$ESCALATION_TOOL ${PACKAGER} upgrade -y
2024-07-13 02:57:34 +01:00
;;
dnf)
2024-08-23 14:12:47 +01:00
$ESCALATION_TOOL ${PACKAGER} update -y
2024-07-13 02:57:34 +01:00
;;
zypper)
2024-08-23 14:12:47 +01:00
$ESCALATION_TOOL ${PACKAGER} ref
$ESCALATION_TOOL ${PACKAGER} --non-interactive dup
2024-07-14 05:02:52 +01:00
;;
yum)
2024-08-23 14:12:47 +01:00
$ESCALATION_TOOL ${PACKAGER} update -y
$ESCALATION_TOOL ${PACKAGER} upgrade -y
2024-07-13 02:57:34 +01:00
;;
2024-07-16 12:49:44 +01:00
xbps-install)
2024-08-23 14:12:47 +01:00
$ESCALATION_TOOL ${PACKAGER} -Syu
2024-07-16 12:49:44 +01:00
;;
2024-07-13 02:57:34 +01:00
*)
echo -e "${RED}Unsupported package manager: $PACKAGER${RC}"
2024-07-13 02:57:34 +01:00
exit 1
;;
esac
}
updateSystem() {
echo -e "${GREEN}Updating system${RC}"
2024-07-13 02:57:34 +01:00
case ${PACKAGER} in
2024-07-14 05:02:52 +01:00
nala|apt-get)
2024-08-23 14:12:47 +01:00
$ESCALATION_TOOL "${PACKAGER}" update -y
$ESCALATION_TOOL "${PACKAGER}" upgrade -y
2024-07-13 02:57:34 +01:00
;;
2024-07-14 05:02:52 +01:00
yum|dnf)
2024-08-23 14:12:47 +01:00
$ESCALATION_TOOL "${PACKAGER}" update -y
$ESCALATION_TOOL "${PACKAGER}" upgrade -y
2024-07-13 02:57:34 +01:00
;;
pacman)
2024-08-23 14:12:47 +01:00
$ESCALATION_TOOL "${PACKAGER}" -Sy --noconfirm --needed archlinux-keyring
$ESCALATION_TOOL "${PACKAGER}" -Su --noconfirm
2024-07-13 02:57:34 +01:00
;;
zypper)
2024-08-23 14:12:47 +01:00
$ESCALATION_TOOL ${PACKAGER} ref
$ESCALATION_TOOL ${PACKAGER} --non-interactive dup
2024-07-13 02:57:34 +01:00
;;
2024-07-16 12:49:44 +01:00
xbps-install)
2024-08-23 14:12:47 +01:00
$ESCALATION_TOOL ${PACKAGER} -Syu
2024-07-16 12:49:44 +01:00
;;
2024-07-13 02:57:34 +01:00
*)
echo -e "${RED}Unsupported package manager: ${PACKAGER}${RC}"
2024-07-13 02:57:34 +01:00
exit 1
;;
esac
}
2024-07-31 11:30:07 +01:00
updateFlatpaks() {
if command_exists flatpak; then
flatpak update -y
fi
}
2024-07-13 02:57:34 +01:00
checkEnv
2024-08-23 14:12:47 +01:00
checkEscalationTool
2024-07-13 02:57:34 +01:00
fastUpdate
2024-07-16 12:49:44 +01:00
updateSystem
2024-07-31 11:30:07 +01:00
updateFlatpaks